

		.16f877


fr		equ		0fh
d		equ		1
k		equ		0abh
b		equ		7
imm		equ		100


;-----------------------------------------------------
;		Microchip Original Instruction Set
;-----------------------------------------------------

		addwf	fr,d
		andwf	fr,d
		clrf	fr
		clrw
		comf	fr,d
		decf	fr,d
		decfsz	fr,d
		incf	fr,d
		incfsz	fr,d
		iorwf	fr,d
		movf	fr,d
		movwf	fr
		nop
		rlf	fr,d
		rrf	fr,d
		subwf	fr,d
		swapf	fr,d
		xorwf	fr,d

		bcf	fr,b
		bsf	fr,b
		btfsc	fr,b
		btfss	fr,b
		addlw	k
		andlw	k
		call	addr
		clrwdt
		goto	addr
		iorlw	k
		movlw	k
		retfie
		retlw	k
		return
		sleep
		sublw	k
		xorlw	k
addr:


;-----------------------------------------------------
;		PA Instruction Set
;-----------------------------------------------------

fa		equ	0fh
fb		equ	01fh
pa		equ	5

		add	w,fr
		add	w,#imm
		add	fa,#imm
		add	fa,fb
		add	fa,w
		addb	fa,fb.b
		addb	fa,/fb.b

		and	w,#imm
		and	w,fa
		and	fa,#imm
		and	fa,fb
		and	fa,w
label
		cja	fa,#imm,label
		cja	fa,fb,label
		cjae	fa,#imm,label
		cjae	fa,fb,label
		cjb	fa,#imm,label
		cjb	fa,fb,label
		cjbe	fa,#imm,label
		cjbe	fa,fb,label
		cje	fa,#imm,label
		cje	fa,fb,label
		cjne	fa,#imm,label
		cjne	fa,fb,label

		clc
		clr	w
		clr	fa
		clr	wdt
		clr	fa.b
		clrb	fa.b
		clz

		csa	fa,#imm
		nop
		csa	fa,fb
		nop
		csae	fa,#imm
		nop
		csae	fa,fb
		nop
		csb	fa,#imm
		nop
		csb	fa,fb
		nop
		csbe	fa,#imm
		nop
		csbe	fa,fb
		nop
		cse	fa,#imm
		nop
		cse	fa,fb
		nop
		csne	fa,#imm
		nop
		csne	fa,fb
		nop

		dec	fa
		decsz	fa
		nop
		djnz	fa,label
		nop
		ijnz	fa,label
		nop
		inc	fa
		incsz	fa
		nop
		jb	fa.b,label
		jc	label

		jmp	pc+w
		jmp	w
		jmp	label

		jnb	fr.b,label
		jnc	label
		jnz	label
		jne	label
		jz	label
		je	label

;		lcall	label
;		ljmp	label
;		lset	label

		mov	w,#imm
		mov	w,fa
		mov	w,/fa
		mov	w,fa-w
		mov	w,++fa
		mov	w,--fa
		mov	w,<<fa
		mov	w,>>fa
		mov	w,<>fa

		mov	option,w
		mov	option,#imm
		mov	option,fa
		mov	fa,w
		mov	fa,fb
		mov	fa,#imm
		mov	!pa,w
		mov	!pa,fa
		mov	!pa,#imm

		movb	fa.b, fb.b
		movb	fa.b, /fb.b

		movsz	w,++fa
		nop
		movsz	w,--fa
		nop

		neg	fa

		nop
		nop	k

		not	w
		not	fa

		or	w,#imm
		or	w,fa
		or	fa,#imm
		or	fa,fb
		or	fa,w

		ret
		retw	k
		retw	'ABCDE'

		rl	fa
		rr	fa

		sb	fa.b
		sc

		setb	fa.b
		skip
		sleep

		snb	fa.b
		snc
		snz
		stc
		stz

		sub	w,fa
		sub	w,#imm
		sub	fa,#imm
		sub	fa,fb
		sub	fa,w
		subb	fa,fb.b
		subb	fa,/fb.b

		swap	fa
		sz

		test	w
		test	fa

		xor	w,#imm
		xor	w,fa
		xor	fa,#imm
		xor	fa,fb
		xor	fa,w


		eeorg	10h
		eedata	1,2,3,4
		eedata	'ABCD'	

		db	1,2,3,4
		db	'ABCD'
		dw	1,2,3,4
		dw	'ABCD'



