		.nlist
;
;	PIC16F877 Header file Version 3.00
;	Copyright (c) 1997-2000 by Masahiro Ochiai
;

		.16f877

indirect	equ	0
indf		equ	0

rtcc		equ	1		; RTCC = TMR0 = 1
tmr0		equ	1
option		equ	1		; OPTION
option_reg	equ	1		; OPTION

ps0		equ	1.0
ps1		equ	1.1
ps2		equ	1.2
psa		equ	1.3
t0se		equ	1.4
t0cs		equ	1.5
intedg		equ	1.6
rbpu		equ	1.7

pc		equ	2		; PC = PCL = 2
pcl		equ	2

status		equ	3		; STATUS
c		equ	3.0		; carry/borrow flag
dc		equ	3.1		; digit carry/borrow flag
z		equ	3.2		; zero flag
pd		equ	3.3		; power down bit
to		equ	3.4		; time out bit
rp0		equ	3.5		; page select
rp1		equ	3.6		;
irp		equ	3.7

fsr		equ	4
porta		equ	5
ra		equ	5
trisa		equ	5

portb		equ	6
rb		equ	6
trisb		equ	6

portc		equ	7
rc		equ	7
trisc		equ	7

portd		equ	8
rd		equ	8
trisd		equ	8

porte		equ	9
re		equ	9
trise		equ	9
re0		equ	re.0
re1		equ	re.1
re2		equ	re.2

trise0		equ	9.0
trise1		equ	9.1
trise2		equ	9.2

pspmode		equ	9.4
ibov		equ	9.5
obf		equ	9.6
ibf		equ	9.7

pclath		equ	0ah

intcon		equ	0bh
rbif		equ	0bh.0
intf		equ	0bh.1
t0if		equ	0bh.2
rbie		equ	0bh.3
inte		equ	0bh.4
t0ie		equ	0bh.5
peie		equ	0bh.6
gie		equ	0bh.7

pir1		equ	0ch
tmr1if		equ	0ch.0
tmr2if		equ	0ch.1
ccp1if		equ	0ch.2
sspif		equ	0ch.3
txif		equ	0ch.4
rcif		equ	0ch.5
adif		equ	0ch.6
pspif		equ	0ch.7

pie1		equ	0ch
tmr1ie		equ	0ch.0
tmr2ie		equ	0ch.1
ccp1ie		equ	0ch.2
sspie		equ	0ch.3
txie		equ	0ch.4
rcie		equ	0ch.5
adie		equ	0ch.6
pspie		equ	0ch.7

pir2		equ	0dh
ccp2if		equ	0dh.0

pie2		equ	0dh
ccp2ie		equ	0dh.0

tmr1l		equ	0eh

pcon		equ	0eh
bor		equ	0eh.0
por		equ	0eh.1

tmr1h		equ	0fh

t1con		equ	10h
tmr1on		equ	10h.0
tmr1cs		equ	10h.1
t1sync		equ	10h.2
t1oscen		equ	10h.3
t1ckps0		equ	10h.4
t1ckps1		equ	10h.5

tmr2		equ	11h

t2con		equ	12h
t2ckps0		equ	12h.0
t2ckps1		equ	12h.1
tmr2on		equ	12h.2
toutps0		equ	12h.3
toutps1		equ	12h.4
toutps2		equ	12h.5
toutps3		equ	12h.6

pr2		equ	12h

sspbuf		equ	13h
sspadd		equ	13h

sspcon		equ	14h
sspm0		equ	14h.0
sspm1		equ	14h.1
sspm2		equ	14h.2
sspm3		equ	14h.3
ckp		equ	14h.4
sspen		equ	14h.5
sspov		equ	14h.6
wcol		equ	14h.7

sspstat		equ	14h
bf		equ	14h.0
ua		equ	14h.1
r_w		equ	14h.2
s		equ	14h.3
p		equ	14h.4
d_a		equ	14h.5

ccpr1l		equ	15h

ccpr1h		equ	16h

ccp1con		equ	17h
ccp1m0		equ	17h.0
ccp1m1		equ	17h.1
ccp1m2		equ	17h.2
ccp1m3		equ	17h.3
ccp1y		equ	17h.4
ccp1x		equ	17h.5

rcsta		equ	18h
rx9d		equ	18h.0
oerr		equ	18h.1
ferr		equ	18h.2

cren		equ	18h.4
sren		equ	18h.5
rx9		equ	18h.6
spen		equ	18h.7

txsta		equ	18h
tx9d		equ	18h.0
trmt		equ	18h.1
brgh		equ	18h.2

sync		equ	18h.4
txen		equ	18h.5
tx9		equ	18h.6
csrc		equ	18h.7

txreg		equ	19h

spbrg		equ	19h

rcreg		equ	1ah

ccpr2l		equ	1bh

ccpr2h		equ	1ch

ccp2con		equ	1dh
ccp2m0		equ	1dh.0
ccp2m1		equ	1dh.1
ccp2m2		equ	1dh.2
ccp2m3		equ	1dh.3
ccp2y		equ	1dh.4
ccp2x		equ	1dh.5

adres		equ	1eh

adcon0		equ	1fh
adon		equ	1fh.0

go_done		equ	1fh.2
chs0		equ	1fh.3
chs1		equ	1fh.4
chs2		equ	1fh.5
adcs0		equ	1fh.6
adcs1		equ	1fh.7

adcon1		equ	1fh
pcfg0		equ	1fh.0
pcfg1		equ	1fh.1
pcfg2		equ	1fh.2

eedata		equ	0ch
eeadr		equ	0dh

eedath		equ	0eh
eeadrh		equ	0fh

eecon1		equ	0ch
eecon2		equ	0dh

eepgd		equ	0ch.7
wrerr		equ	0ch.3
wren		equ	0ch.2
wr			equ	0ch.1
;rd			equ	0ch.0


		.list
